﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Diagnostics;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Threading;
using Infragistics.Controls.Charts;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent(); 

            DataContext = Data.GetData(10, 50, 100);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            (xamDataChart.Series[0] as ColumnSeries).LegendItemTemplate = grid1.Resources["legendItemTemplate"] as DataTemplate;
            (xamDataChart.Series[0] as ColumnSeries).LegendItemBadgeTemplate = grid1.Resources["legendItemBadgeTemplate"] as DataTemplate;
        }

        private void WaterWater_Click(object sender, RoutedEventArgs e)
        {

        }
    }

    public class Data : INotifyPropertyChanged
    {  
        private double value;
        private DateTime date;

        public DateTime Date
        {
            get { return date; }
            set
            {
                date = value;
                PropChanged("Date");
            }
        }

        public double Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Date = DateTime.Now.AddDays(i),
                    Value = r.Next(rangeStart, rangeStart) + r.NextDouble(),
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
